Draft Draft2Sketch: Difference between revisions

From FreeCAD Documentation
(Updated Notes)
(Updated Usage)
Line 36: Line 36:
<!--T:4-->
<!--T:4-->
# Select a Draft object or a Sketch.
# Select a Draft object or a Sketch.
# There are several ways to invoke the command:
# Press the {{Button|[[Image:Draft Draft2Sketch.svg|16px]] [[Draft_Draft2Sketch|Draft Draft2Sketch]]}} button.
#* Press the {{Button|[[Image:Draft_Draft2Sketch.svg|16px]] [[Draft_Draft2Sketch|Draft Draft2Sketch]]}} button.

#* Select the {{MenuCommand|Modification → [[Image:Draft_Draft2Sketch.svg|16px]] Draft to Sketch}} option from the menu.

# A new object is created.
* If you convert a [[Image:Draft_Wire.svg|16px]] [[Draft_Wire|Draft Wire]], the resulting sketch will use point constraints for the nodes.
* If you convert a [[Image:Draft_Rectangle.svg|16px]] [[Draft_Rectangle|Draft Rectangle]], the resulting sketch will use point constraints for the corners, and horizontal and vertical constraints for the edges.


== Notes ==
== Notes ==

Revision as of 07:57, 13 June 2021

This documentation is a work in progress. Please don't mark it as translatable since it will change in the next hours and days.

Draft Draft2Sketch

Menu location
Modification → Draft to Sketch
Workbenches
Draft, Arch
Default shortcut
None
Introduced in version
-
See also
Sketcher, PartDesign

Description

The Draft Draft2Sketch tool converts Draft objects to Sketcher Sketches, and vice-versa.

Converting Draft shapes into Sketcher shapes with constraints

Usage

  1. Select a Draft object or a Sketch.
  2. There are several ways to invoke the command:
    • Press the Draft Draft2Sketch button.
    • Select the Modification → Draft to Sketch option from the menu.
  3. A new object is created.

Notes

Scripting

See also: Autogenerated API documentation and FreeCAD Scripting Basics.

To convert objects to a sketch use the make_sketch method (introduced in version 0.19) of the Draft module. This method replaces the deprecated makeSketch method.

sketch = make_sketch(objects_list, autoconstraints=False, addTo=None, delete=False, name="Sketch", radiusPrecision=-1, tol=1e-3)
  • objects_list contains the objects to be converted. It is either a single object or a list of objects. Draft objects, Part::Feature objects and Part.Shape objects are supported.
  • If autoconstraints is True coincident constraints are added to nodes belonging to the same source object.
  • addTo is the existing sketch object the geometry is added to. If not supplied a new sketch is created.
  • If delete is True the source objects are deleted.
  • name is the name for the new sketch.
  • radiusPrecision indicates how radius constraints should be handled:
    • Use -1 to disable radius constraints.
    • Use 0 to add individual radius constraints.
    • Use a positive number to round radii according to this precision, and to add equal constraints between curves with equal radii.
  • tol is the tolerance used to check if shapes are planar and co-planar. Use -1 for a strict analysis.
  • sketch is returned with the sketch object.

To convert a sketch to Draft objects use the draftify method of the Draft module.

draftify(objectslist, makeblock=False, delete=True)
  • objectslist contains the objects to be converted. It is either a single object or a list of objects.
  • If makeblock is True the converted objects are grouped in a Part::Part2DObject.
  • If delete is True the source objects are deleted.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

rectangle = Draft.make_rectangle(2000, 1000)
circle = Draft.make_circle(500)
doc.recompute()

sketch_from_draft = Draft.make_sketch([rectangle, circle], autoconstraints=True, delete=False, radiusPrecision=0)
doc.recompute()

draft_from_sketch = Draft.draftify(sketch_from_draft, delete=False)
doc.recompute()